package info.textgrid.middleware;

import java.io.IOException;
import java.text.ParseException;
import javax.xml.datatype.DatatypeConfigurationException;
import info.textgrid.middleware.oaipmh.HeaderType;
import info.textgrid.middleware.oaipmh.ListIdentifiersType;
import info.textgrid.middleware.oaipmh.ResumptionTokenType;

public class OpenAireIdentifierList extends IdentifierListDelivererAbstract {

  public ResumptionTokenType resTokenForResponse;

  public OpenAireIdentifierList(boolean textgrid, boolean dariah) {
    super(textgrid, dariah);
    // TODO Auto-generated constructor stub
  }

  public ListIdentifiersType processIdentifierList(String from, String to, String set,
      String resumptionToken) throws IOException {

    ListIdentifiersType openAireIddentifiersList = new ListIdentifiersType();
    // List<String> uriList = new ArrayList<String>();
    // OAIPMHUtilities oaipmhUtilities = new OAIPMHUtilities();

    for (String uri : getUriListOfAllEditions(from, to, set, resumptionToken)) {

      OpenAireRecord openAireRecord = new OpenAireRecord(true, false);
      HeaderType header = new HeaderType();

      try {
        header = openAireRecord.getRecordById(uri.replace("textgrid:", "")).getRecord().getHeader();
      } catch (ParseException | DatatypeConfigurationException e) {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
      openAireIddentifiersList.getHeader().add(header);
    }


    // if(oaipmhUtilities.getResTokenForResponse()!=null) {
    openAireIddentifiersList.setResumptionToken(getResTokenForResponse());
    // }
    return openAireIddentifiersList;
  }
}
